



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【译】3. Java反射——构造函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【译】3. Java反射——构造函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 18:14:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><em>原文地址：<a href="http://tutorials.jenkov.com/java-reflection/constructors.html" rel="external nofollow noreferrer">http://tutorials.jenkov.com/java-reflection/constructors.html</a></em></p>
<p><em>=====================================================================================================</em></p>
<p>使用Java反射，你可以在运行时检查类的构造函数和实例化对象。这是通过Java类java.lang.reflect.Constructor做的。本文将会更详细的介绍Java中的Constructor对象。下面是所涵盖的主题列表：</p>
<ol><li>Obtaining Constructor Objects&nbsp;（获取Constructor对象）</li>
<li>Constructor Parameters&nbsp;（Constructor的参数）</li>
<li>Instantiating Objects using Constructor Object&nbsp;（通过Constructor对象实例化对象）</li></ol>
<p><em>=====================================================================================================</em></p>
<ul><li><strong>Obtaining Constructor Objects</strong></li></ul>
<p>Constructor对象可以从Class对象中获取。下面是一个例子：</p>
<div>
<pre class="prettyprint linenums">Class aClass = ...//obtain class object<br />
Constructor[] constructors = aClass.getConstructors();</pre>
</div>
<p>数组Constructor[ ]将会存储在类中所有声明为public的构造函数的Constructor实例。<br />&nbsp; &nbsp; &nbsp;如果你知道你要访问的构造函数的精确参数类型，你可以这样做而不是获取所有的构造函数。这个例子返回给定类的一个public的且接收一个String类型的变量作为参数的构造函数：</p>
<div>
<pre class="prettyprint linenums">Class aClass = ...//obtain class object<br />
Constructor constructor = aClass.getConstructor(new Class[]{String.class});</pre>
</div>
<p>如果没有和给定的参数相匹配的构造函数，会抛出NoSuchMethodException异常。</p>
<p><em>=====================================================================================================</em></p>
<ul><li><strong>Constructor Parameters</strong></li></ul>
<p>你可以像这样读取一个给定的构造函数所接收的参数：</p>
<div>
<pre class="prettyprint linenums">Constructor constructor = ... // obtain constructor - see above<br />
Class[] parameterTypes = constructor.getParameterTypes();</pre>
</div>
<p><em>=====================================================================================================</em></p>
<ul><li><strong>Instantiating Objects using Constructor Object</strong></li></ul>
<p>你可以像这样实例化一个对象：</p>
<div>
<pre class="prettyprint linenums">//get constructor that takes a String as argument<br />
Constructor constructor = MyObject.class.getConstructor(String.class);<br />
MyObject myObject = (MyObject) constructor.newInstance("constructor-arg1");</pre>
</div>
<p>Constructor.newInstance( )方法接受不定个数的参数，但是你必须提供你调用的构造函数需要的每个参数。在这种情况下，调用接受一个String类型参数的构造函数，你必须提供一个String类型的参数。</p>
<p><em>========================================================================================</em></p>
<ul><li><strong>目录</strong></li></ul>
<p>　　这是一个本教程到目前为止涵盖的主题列表：</p>
<ol><li><a href="http://www.cnblogs.com/penghongwei/p/3299688.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;引言</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300047.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;Class对象</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300063.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;构造函数</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300073.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;字段</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300078.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;方法</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300081.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;Getter和Setter</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300084.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;私有字段和私有方法</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300087.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;注解</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300091.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;泛型</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300094.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;数组</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300098.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;动态代理</a></li>
<li><a href="http://www.cnblogs.com/penghongwei/p/3300103.html" rel="external nofollow noreferrer">Java反射&mdash;&mdash;类的动态加载和重新加载</a></li></ol>
<p>(敬请期待下一篇翻译)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96gp384.html">atitit&period;软件与sql设计模式原理与本质 大总结attialx总结v6 qc26&period;docx</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgwj39.html">jboss端口说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glkkeq.html">jar包和war包的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k102wr9.html">【python cookbook】【字符串与文本】8&period;编写多行模式的正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdxn79.html">算法（第4版）-1&period;1&period;1 Java程序的基本结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewkmz9.html">java&period;lang&period;StackOverflowError&colon; stack size 8MB</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdv6yk8.html">【翻译习作】 Windows Workflow Foundation程序开发-第一章04</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mny7d6q.html">MSP430F4152串口操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03d3wq.html">mybatis 与 反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvg7ryq.html">Umbraco学习1------安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0k1n9.html">Microsoft Azure 上的自定义数据和 Cloud-Init</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mm15n8.html">FZU1669 Right-angled Triangle【毕达哥拉斯三元组】</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mp5jj8.html">【JAVAEE学习笔记】hibernate02：实体规则、对象状态、缓存、事务、批量查询和实现客户列表显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd2r3y9.html">python学习笔记&mdash;&mdash;Day 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0rv38.html">mysql数据库索引优化与实践（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxwg38.html">在MongoDB中创建一个索引而性能提升1000倍的小例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10ope9.html">JavaScript代码优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvo5ll8.html">Java遍历HashMap并修改&lpar;remove&rpar;（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyrmgx9.html">关于树的常见操作-C&plus;&plus;面试</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wk4gnq.html">codeforces518B</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wj7vnq.html">python学习笔记&lpar;2&rpar;--基本语法元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5ym48.html">有时候做JQ动画，鼠标经过，它会不停自己抖动不停，解决方法（此处，是兼容IE ，当鼠标经过，遮罩层从下移到上边的JQ动画效果）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj3r5e9.html">python工具使用笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmry69.html">华硕X99-A II 安装使用 志强 XEON E5-1603 v4</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5n708.html">Linux下tomcat中多项目配置druid报错的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j41ynq.html">visual studio 显示引用关系 作者更改项</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1e4nl9.html">FAQ常见问题解答---搭建hubot</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1d06lq.html">Ionic生命周期与注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2d73oq.html">Pfsense2&period;34中文版</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2dmgz9.html">睡眠麻痹 CSP HSP</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
